#include "synthesizer.h"

unsigned char GetPWM(PolyStream* stream)
{
    unsigned char i = stream->len - 1;
    unsigned short pwm = 0;
    do
    {
        pwm += GetTone(&(stream->stream[i]));
    }
    while(i--);
    pwm >> stream->loglen;
    return (unsigned char)pwm;
}

unsigned char GetTone(Stream* stream)
{
    if(++stream->tonepos == stream->stream[stream->streampos].len) //Ton zu Ende?
    {
        stream->tonepos = 0;    //Werte zurcksetzen
        stream->tonepwmpos = 0;
        stream->streampos++;   //nchster Ton
    }
    if(stream->streampos >= stream->len)
        return 128;
    if(stream->stream[stream->streampos].pwm > ++stream->tonepwmpos)
    {
        //printf("Vol: %d [%d,%d]\n", (int) stream->stream[stream->streampos].volume,(int) stream->stream[stream->streampos].pwm,(int) stream->stream[stream->streampos].len);
        return stream->stream[stream->streampos].volume;
    }
    else
        if(stream->tonepwmpos == stream->stream[stream->streampos].max)
        {
            stream->tonepos++;
            stream->tonepwmpos = 0;
        }
    return 255 - stream->stream[stream->streampos].volume;
}

Tone CreateTone(unsigned char pwm, unsigned char volume, unsigned short len)
{
    Tone t;
    t.pwm = pwm >> 1;
    t.max = pwm;
    t.volume = volume;
    t.len = len;
    return t;
}
Stream CreateStream(Tone* stream, unsigned char len)
{
    Stream s;
    s.stream = stream;
    s.len = len;
    s.streampos = s.tonepwmpos = s.tonepos = 0;
    return s;  
}
PolyStream CreatePolyStream(Stream* stream, unsigned char loglen)
{
    PolyStream p;
    p.stream = stream;
    p.loglen = loglen;
    p.len = 1 << loglen;
    return p;
}
