#ifndef SYNTH
#define SYNTH

#include <stdio.h>

#define TONE_MODE_PLAY 0
#define TONE_MODE_DELAY 1
#define TONE_MODE_END 2

struct Tone
{
    unsigned char pwm;
    unsigned char max;
    unsigned char volume;
    unsigned short len;
};

struct Stream
{
    Tone* stream;
    unsigned char len;
    unsigned char streampos;
    unsigned char tonepwmpos;
    unsigned short tonepos;
};

struct PolyStream
{
    Stream* stream;
    unsigned char len;
    unsigned char loglen;   
};

unsigned char GetPWM(PolyStream* stream);
unsigned char GetTone(Stream* stream);

Tone CreateTone(unsigned char pwm, unsigned char volume, unsigned short len);
Stream CreateStream(Tone* stream, unsigned char len);
PolyStream CreatePolyStream(Stream* stream, unsigned char loglen); //1<<loglen ^= len(stream) 

#endif
